Subject: Re: question: update_pmtu doesn't update dst mtu

From: "Ilya V. Matveychikov" <[email-masked]>
Date: Thu, 3 Apr 2014 16:07:21 +0400

On 03.04.2014 15:58, Hannes Frederic Sowa wrote:
> On Thu, Apr 03, 2014 at 03:37:33PM +0400, Ilya V. Matveychikov wrote:
>> Looking through the code gives me that rt_pmtu is always 0 for the skb->dst
>> entry and ipv4_mtu that called via the dst->ops->mtu() uses dev->mtu :(
> 
> At this point you have to drop skb_dst and have to relookup the route. During
> that a new dst will be created which gets the mtu value from the next hop
> exception, which got created by update_pmtu.
> 
> Normally routes are checked with dst_check if they are still valid
> and a relookup should happen. In your example just do the relookup
> unconditionally.
> 

Does it mean that the next packet must have an updated route without any
problems? I meant that if the first packet xmitting leads to updating the route
PMTU via the exception creating (or updating) so the next packets must have an
updated route? Am I right?